const set = (x = []) => x instanceof Set ? x : new Set(x);
const and = (a, b) => {
    const A = set(a);
    const B = set(b);
    return set([...A].filter(x => B.has(x)));
};
const or = (a, b) => set([...a, ...b]);
const not = (a, b) => {
    const A = set(a);
    const B = set(b);
    return set([...A].filter(x => !B.has(x)));
};
const xor = (a, b) => not(or(a, b), and(a, b));
const equal = (a, b) => {
    const A = set(a);
    const B = set(b);
    return A.size === B.size && [...A].every(x => B.has(x));
};
const subset = (a, b) => {
    const A = set(a);
    const B = set(b);
    return [...A].every(x => B.has(x));
};
const strictSubset = (a, b) => {
    const A = set(a);
    const B = set(b);
    return A.size < B.size && [...A].every(x => B.has(x));
};
const superset = (a, b) => subset(b, a);
const strictSuperset = (a, b) => strictSubset(b, a);
const intersects = (a, b) => and(a, b).size > 0;
const excludes = (a, b) => and(a, b).size === 0;
export { set, and, and as intersect, or, or as union, not, not as subtract, not as difference, xor, equal, subset, strictSubset, superset, strictSuperset, intersects, excludes };
